{*
 PasMatLib - The Form for embedded signal plot
 Nikolai V. Shokhirev, 2001-2007
 @author Nikolai V. Shokhirev <nikolai@shokhirev.com> http://www.shokhirev.com/nikolai.html
 @version 2007.09.27 - created
 }
unit fSignalPlot;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls
  , uDynArrays
  , uSignalPlot
  ;

type
  TFormSignalPlot = class(TForm)
    PanelScrollbar: TPanel;
    PanelChart: TPanel;
    ScrollBar: TScrollBar;
    PB: TPaintBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PBPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
    aMax: integer;
  public
    { Public declarations }
    Y: IFArr2D;
    SP: TSignalPlot;
  end;

var
  FormSignalPlot: TFormSignalPlot;

implementation

{$R *.dfm}

procedure TFormSignalPlot.FormCreate(Sender: TObject);
begin
  SP := TSignalPlot.Create(PB.Canvas,PB.ClientWidth, PB.ClientHeight, 10, 10, 10, 10);
  SP.Step := 3;
end;

procedure TFormSignalPlot.FormDestroy(Sender: TObject);
begin
  SP.Free;
end;

procedure TFormSignalPlot.PBPaint(Sender: TObject);
var
  BrushColor: TColor;
begin
  SP.SetDims(PB.ClientWidth, PB.ClientHeight);
  SP.DrawFrame(clDkGray,5,5,'X-Axis','Y-Axis');

  aMax := ScrollBar.Position;
{
  if CheckBoxFilled.Checked then
    BrushColor := clBlue
  else
    BrushColor := clWhite;
}
{
  case RadioGroupType.ItemIndex of
  0: SP.DrawPlot(Y, aMax, clBlue);
  1: SP.DrawBars(Y, aMax, clBlue, CheckBoxLeftLine.Checked,
                  CheckBoxRightLine.Checked, CheckBoxFromZero.Checked);
  2: SP.DrawDots(Y, aMax, StrToInt(EditR.Text), clBlue, BrushColor);
  end;
}
end;

procedure TFormSignalPlot.FormResize(Sender: TObject);
begin
  ScrollBar.Min := SP.GetVisiblePoints+1;
end;

end.
