{@abstract(procedure PlotF)
@author(Nikolai Shokhirev <nikolai@shokhirev.com>)
@created(June 6, 2002)
@lastmod(January 19, 2003)
Nikolai V. Shokhirev, 2002-2003 }
unit uFourierDisplay;

interface

uses
  uMatTypes, extctrls, uArrays;

procedure PlotF(const PaintBox: TPaintBox; const f: IVector; caption: string);

implementation

uses
  Graphics, math;

procedure PlotF(const PaintBox: TPaintBox; const f: IVector; caption: string);
const
  d = 8;
var
  HH, H1, H2, m, i, N : TInt;
  fMin, fMax, df: TFloat;

  function iy(y: TFloat): TInt;
  begin
    result := H1 - round(H2*(y-fMin)/df);
  end;

begin
  N := f.Dim;
  fMax := -MaxFloat;
  fMin :=  MaxFloat;
  for m := 1 to N do
  begin
    fMax := max(fMax,f[m]);
    fMin := min(fMin,f[m]);
  end;
  
  df := fMax-fMin;
  if df = 0.0 then df := 1.0;

  HH := PaintBox.ClientHeight;
  H1 := HH-d;
  H2 := HH-d-d;
  with PaintBox.Canvas do
  begin
    Brush.Color := clWhite;
    FillRect(PaintBox.ClientRect);
    Pen.Color := clRed;
    if fMin*fMax <= 0.0 then
    begin
      i := iy(0.0);
      MoveTo( 0, i);
      LineTo(N-1,i);
    end;
    i := (N - 1) div 2;
    MoveTo(i, d div 2);
    LineTo(i, HH-(d div 2));
    Pen.Color := clBlue;
//    i := H1 - round(H2*(f[1]-fMin)/df);
    i := iy(f[1]);
    MoveTo(0, i);
    for m := 1 to N-1 do
    begin
//    i := H1 - round(H2*(f[m+1]-fMin)/df);
    i := iy(f[m+1]);
    LineTo(m, i);
    end;
    TextOut(1,1,caption);
  end;
end;

end.
