unit fTestData2D;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  uMatTypes, uGraph2D, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    PanelBox: TPanel;
    Label1: TLabel;
    EditXmin: TEdit;
    Label2: TLabel;
    EditXmax: TEdit;
    Label3: TLabel;
    EditYmin: TEdit;
    Label4: TLabel;
    EditYmax: TEdit;
    ButtonPlot: TButton;
    CheckBoxX: TCheckBox;
    CheckBoxY: TCheckBox;
    Label5: TLabel;
    EditRatio: TEdit;
    EditStep: TEdit;
    Label6: TLabel;
    EditA: TEdit;
    Label7: TLabel;
    EditB: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure ButtonPlotClick(Sender: TObject);
  private
    { Private declarations }
    PlotBox2D: TPlotBox2D;
    procedure Plotting;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  PlotBox2D := TPlotBox2D.Create(self, PanelBox);
  PlotBox2D.YTitle := 'X';
  PlotBox2D.XTitle := 't';
  PlotBox2D.OnPaint := ButtonPlotClick;
end;

procedure TForm1.Plotting;
var
  Ymax, Ymin, Tmax, Tmin, f, ff,
  a, b, x, y, t, step, xx, yy,
  t1, t2, f1, f2, Factor: TFloat;
  XAxis, YAxis: boolean;
  NXTicks, NYTicks, i, imax,
  j, j0: TInt;

  xPoints, yPoints, tPoints: array of array of TFloat;

  procedure xyToPlane(x, y: TFloat; var xx, yy: TFloat);
  var
    f: TFloat;
  begin
    if abs(y) < 1.0e-99 then f := 0.0 else f := sqr(y)/(sqr(y)+sqr(x)+1.0e-11);
    f := a*Pi*f;
    xx := x*Cos(f)-y*Sin(f);
    yy := Factor*(y*Cos(f)+x*Sin(f));
  end;

  function f12(x, x1, x2, y1, y2: TFloat): TFloat;
  begin
    result := (y1*(x2-x)+y2*(x-x1))/(x2-x1);
  end;

begin
  Tmax := StrToFloat(EditXmax.Text);
  Tmin := StrToFloat(EditXmin.Text);
  a := StrToFloat(EditA.text);
  b := StrToFloat(EditB.text);
  step := StrToFloat(EditStep.text);
  NXTicks := 4;

  Ymax := StrToFloat(EditYmax.Text);
  Ymin := StrToFloat(EditYmin.Text);
  NYTicks := 5;

  XAxis := CheckBoxX.Checked;
  YAxis := CheckBoxY.Checked;
  PlotBox2D.SetLimits(Tmin-10, Tmax+ 10, Ymin, Ymax);
  PlotBox2D.PlotFrame;
  Factor := 1.0;
//  PlotBox2D.
  PlotBox2D.PenColor := clBlue;
  imax := round((Tmax-Tmin)/step);

  SetLength(xPoints,imax+1, 2);
  SetLength(yPoints,imax+1, 2);
  SetLength(tPoints,imax+1, 2);


  t := Tmin;
//  xyToPlane(7.0, 0.0, xx, yy);
//  PlotBox2D.MoveToF(t-yy,xx);
  for i := 0 to imax do
  begin
    x := 8.0*Cos(b*(t-Tmin));
    y := 8.0*Sin(b*(t-Tmin));
    tPoints[i,0] := t;
    tPoints[i,1] := 0.0;
    xyToPlane(0.0, y, xx, yy);
    yPoints[i,0] := t-yy;
    yPoints[i,1] := xx;
    xyToPlane(x, 0.0, xx, yy);  // yy = 0, xx = x
    xPoints[i,0] := t-yy;
    xPoints[i,1] := xx;
    t := t + step;
  end;

  PlotBox2D.PenWidth := 1;
  PlotBox2D.PenColor := clDkGray;
  PlotBox2D.MoveToF(Tmin,0.0);
  PlotBox2D.LineToF(Tmax,0.0);

  PlotBox2D.PenColor := clRed;
  PlotBox2D.MoveToF(Tmin,Ymin);
  PlotBox2D.LineToF(Tmin,Ymax);
  for i := 0 to imax do
  if (i mod 4) = 3 then
  begin
    PlotBox2D.MoveToF(tPoints[i,0],tPoints[i,1]);
    PlotBox2D.LineToF(xPoints[i,0],xPoints[i,1]);
  end;

  PlotBox2D.PenColor := clBlue;
  xyToPlane(0.0, Ymin, xx, yy);
  PlotBox2D.MoveToF(Tmin-yy,xx);
  xyToPlane(0.0, Ymax, xx, yy);
  PlotBox2D.LineToF(Tmin-yy,xx);
  for i := 0 to imax do
  if (i mod 4) = 1 then
  begin
    PlotBox2D.MoveToF(tPoints[i,0],tPoints[i,1]);
    PlotBox2D.LineToF(yPoints[i,0],yPoints[i,1]);
  end;

  PlotBox2D.PenWidth := 2;

  PlotBox2D.PenColor := clRed;
  PlotBox2D.MoveToF(xPoints[0,0],xPoints[0,1]);
  for i := 1 to imax do
  begin
    PlotBox2D.LineToF(xPoints[i,0],xPoints[i,1]);
  end;

  PlotBox2D.PenColor := clBlue;
  PlotBox2D.MoveToF(yPoints[0,0],yPoints[0,1]);
  for i := 1 to imax do
  begin
    PlotBox2D.LineToF(yPoints[i,0],yPoints[i,1]);
  end;

  PlotBox2D.PenWidth := 1;

(*
//  PlotBox2D.PenWidth := 2;
  for i := 0 to imax do
  begin
  PlotBox2D.PenColor := clBlue;

  
    PlotBox2D.MoveToF(tPoints[i,0],tPoints[i,1]);
    PlotBox2D.LineToF(yPoints[i,0],yPoints[i,1]);

  PlotBox2D.PenColor := clGreen;
    j0 := imax+1;
    for j := 1 to imax do
    begin
      t  := xPoints[i,0];
      t1 := yPoints[j-1,0];
      t2 := yPoints[j,0];
      if (t1 < t) and (t <= t2) then
      begin
        j0 := j;
        f1 := yPoints[j-1,1];
        f2 := yPoints[j,1];
        f  := f12(t, t1, t2, f1, f2);
        break;
      end;
    end;

    ff := xPoints[i,1];
//    if (j0 <= imax) and (f < 0.0) then
    if (ff < 0.0) and (f < 0.0) then
    begin
      if (ff < f) then
      begin
        PlotBox2D.MoveToF(t,f);
        PlotBox2D.LineToF(xPoints[i,0],xPoints[i,1]);
      end;
    end else
    begin
      PlotBox2D.MoveToF(tPoints[i,0],tPoints[i,1]);
//    if (j0 <= imax) and (xPoints[i,1] < f) then
      PlotBox2D.LineToF(xPoints[i,0],xPoints[i,1]);
    end;
  end;
*)
{
//  PlotBox2D.PenWidth := 2;
  t := Tmin;
//  xyToPlane(7.0, 0.0, xx, yy);
//  PlotBox2D.MoveToF(t-yy,xx);
  for i := 0 to imax do
  begin
    x := 7.0*Cos(b*(t-Tmin));
    y := 7.0*Sin(b*(t-Tmin));

  PlotBox2D.PenColor := clBlue;
    xyToPlane(0.0, y, xx, yy);
    PlotBox2D.MoveToF(t,0.0);
    PlotBox2D.LineToF(t-yy,xx);
  PlotBox2D.PenColor := clGreen;
    xyToPlane(x, 0.0, xx, yy);
    PlotBox2D.MoveToF(t,0.0);
    PlotBox2D.LineToF(t-yy,xx);

//  PlotBox2D.PenColor := clRed;
//    xyToPlane(x, y, xx, yy);
//    PlotBox2D.MoveToF(t,0.0);
//    PlotBox2D.LineToF(t-yy,xx);

    t := t + step;
  end;
}
end;

procedure TForm1.ButtonPlotClick(Sender: TObject);
begin
  PlotBox2D.XCaption := CheckBoxX.Checked;
  PlotBox2D.YCaption := CheckBoxY.Checked;
  Plotting;
end;

end.
