{@abstract(Fourier demo, uFourier Test)
@author(Nikolai V. Shokhirev <nikolai@shokhirev.com> <nikolai@u.arizona.edu>)
@created(June 15, 2003)
@lastmod(February 02, 2003)
Nikolai V. Shokhirev, 2002-2003 }
unit fFourier;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  uMatTypes, StdCtrls, uDisplay, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Label6: TLabel;
    EditN: TEdit;
    LabelCyc: TLabel;
    EditCycle: TEdit;
    UpDown1: TUpDown;
    CheckBoxIm: TCheckBox;
    ButtonCFTG: TButton;
    ButtonFourierR: TButton;
    ButtonFourier: TButton;
    ButtonFourierSym: TButton;
    RadioGroupTest: TRadioGroup;
    ButtonTest: TButton;
    LabelEven: TLabel;
    ButtonFFTG: TButton;
    procedure ButtonFourierRClick(Sender: TObject);
    procedure ButtonFourierClick(Sender: TObject);
    procedure ButtonFourierSymClick(Sender: TObject);
    procedure ButtonCFTGClick(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure RadioGroupTestClick(Sender: TObject);
    procedure EditCycleExit(Sender: TObject);
    procedure ButtonTestClick(Sender: TObject);
    procedure ButtonFFTGClick(Sender: TObject);
  private
    { Private declarations }
    procedure Captions;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  uDynArrays,  uFourier;

{$R *.DFM}

procedure TForm1.ButtonFourierRClick(Sender: TObject);
var
  c: ICArr1D;
  x, xx: IFArr1D;
  N, i, j, m: TInt;
  a, f, ff, t, rN: TFloat;
  s: string;
begin
  Memo1.Clear;
  N := StrToInt(EditN.Text);
  if N < 2 then N := 2;

  x := TFArr1D.Create(N);
  rN := 1.0/N;
//  t := 0.0;
  i := StrToInt(EditCycle.Text);
  f := i;
  if i = 0 then ff := 0.101010101 else ff := abs(f);
  for j := 0 to N-1 do
  begin
    a := 2.0*Pi*f*j*rN;
    if f < 0.0 then
      x[j+1] := sin(a)*ff
    else
      x[j+1] := cos(a)*ff;
  end;

  c := DFTR(x);
  xx := InvDFTR(c, N);

  Memo1.Clear;
  Memo1.Lines.Add(Format('N=%d',[N]));
  Memo1.Lines.Add('   Input             InvDFTR(Coeff)    Coeff = DFTR(Input)');
  For j := 1 to N do
  begin
    s := RealToStr(x[j],16,12)+' |'+RealToStr(xx[j],16,12);
    if j <= c.Dim1 then
      s := s+' |'+CmplxToStr0(c[j],16,12);
    Memo1.Lines.Add(s);
  end;

  Memo1.Lines.Add(' -----------------------------------');
  Memo1.Lines.Add('   Interpolation       Input');
  t := 0.0;
  for m := 1 to 2*N+1 do
  begin
    f := InterpolDFTR(t, rN, c, N);
    s := RealToStr(f,16,12);
    j := (m+1) div 2;
    i := (m+1) mod 2;
    if (i=0) and (j<=N) then s := s +  '  <-'+ RealToStr(x[j],16,12);
    Memo1.Lines.Add(s);
    t := t + 0.5*rN;
  end;

end;

procedure TForm1.ButtonFourierClick(Sender: TObject);
var
  x, c, xy: ICArr1D;
  N, m, i, j: TInt;
  t, rN, f, ff, a: TFloat;
  z: Complex;
  s: string;
begin
  N := StrToInt(EditN.Text);
  rN := 1.0/N;

  x := TCArr1D.Create(N);
  i := StrToInt(EditCycle.Text);
  f := i;
  if i = 0 then ff := 0.101010101 else ff := abs(f);
  for j := 0 to N-1 do
  begin
    a := 2.0*Pi*f*j/N;
    if CheckBoxIm.Checked then
      x[j+1] := cmplx(-sin(a)*ff, cos(a)*ff)
    else
      x[j+1] := cmplx(cos(a)*ff, sin(a)*ff);
  end;

  c := DFT(x);
  xy := InvDFT(c);

  Memo1.Clear;
  Memo1.Lines.Add(Format('N=%d',[N]));
  Memo1.Lines.Add('   Input                         Coeff = DFT(Input)            InvDFT(Input)');
  For j := 1 to N do
  begin
    s := CmplxToStr0(x[j],13,9)+' |'+CmplxToStr0(c[j],13,9)+' |'
        +CmplxToStr0(xy[j],13,9);
    Memo1.Lines.Add(s);
  end;

  Memo1.Lines.Add(' ----------------------------------------------------------');
  Memo1.Lines.Add('   Interpolation                  Input');
  t := 0.0;
  for m := 1 to 2*N+1 do
  begin
    z := InterpolDFT(t, rN, c);
    s := CmplxToStr0(z,13,9);
    j := (m+1) div 2;
    i := (m+1) mod 2;
    if (i=0) and (j<=N) then s := s + ' <-' + CmplxToStr0(x[j],13,9);
    Memo1.Lines.Add(s);
    t := t + 0.5*rN;
  end;
end;

procedure TForm1.ButtonFourierSymClick(Sender: TObject);
var
  x, c, xy: ICArr1D;
  N, m, i, j: TInt;
  t, rN, f, ff, a: TFloat;
  z: Complex;
  s: string;
begin
  N := StrToInt(EditN.Text);
  N := (N div 2)*2;
  EditN.Text := IntToStr(N);
  rN := 1.0/N;

  x := TCArr1D.Create(N);
  i := StrToInt(EditCycle.Text);
  f := i;
  if i = 0 then ff := 0.101010101 else ff := abs(f);
  for j := 0 to N-1 do
  begin
    a := 2.0*Pi*f*j/N;
    if CheckBoxIm.Checked then
      x[j+1] := cmplx(-sin(a)*ff, cos(a)*ff)
    else
      x[j+1] := cmplx(cos(a)*ff, sin(a)*ff);
  end;

  Memo1.Clear;

  c := DFTSym(x);

  xy := InvDFTSym(c);

  Memo1.Clear;
  Memo1.Lines.Add(Format('N=%d',[N]));
  Memo1.Lines.Add('   Input                         Coeff = DFTSym(Input)         InvDFTSum(Input)');
  For j := 1 to N do
  begin
    s := CmplxToStr0(x[j],13,9)+' |'+CmplxToStr0(c[j],13,9)+' |'
        +CmplxToStr0(xy[j],13,9);
    Memo1.Lines.Add(s);
  end;

  Memo1.Lines.Add(' ----------------------------------------------------------');
  Memo1.Lines.Add('   Interpolation                  Input');
  t := 0.0;
  for m := 1 to 2*N+1 do
  begin
    z := InterpolSym(t, rN, c);
    s := CmplxToStr0(z,13,9);
    j := (m+1) div 2;
    i := (m+1) mod 2;
    if (i=0) and (j<=N) then s := s + ' <-' + CmplxToStr0(x[j],13,9);
    Memo1.Lines.Add(s);
    t := t + 0.5*rN;
  end;
end;

procedure TForm1.ButtonCFTGClick(Sender: TObject);
var
  j, i, N, m: TInt;
  t, rN, a , f, ff: TFloat;
  s: string;
  z: Complex;
  Cinp, Cout, CScr, CInv: ICArr1D;
begin
  Memo1.Clear;
  N := StrToInt(EditN.Text);
  if N < 2 then N := 2;
  rN := 1.0/N;

  Cinp := TCArr1D.Create(N);
  Cout := TCArr1D.Create(N);
  CScr := TCArr1D.Create(N);
  CInv := TCArr1D.Create(N);

  i := StrToInt(EditCycle.Text);
  f := i;
  if i = 0 then ff := 0.101010101 else ff := abs(f);
  for j := 0 to N-1 do
  begin
    a := 2.0*Pi*f*j/N;
    if CheckBoxIm.Checked then
      Cinp[j+1] := cmplx(-sin(a)*ff, cos(a)*ff)
    else
      Cinp[j+1] := cmplx(cos(a)*ff, sin(a)*ff);
  end;

  CFTG(Cinp,Cout,CScr,+N);
  CFTG(Cout,CInv,CScr,-N);

  Memo1.Lines.Add(Format('N=%d',[N]));
  Memo1.Lines.Add('   Input                         CFTG(Input,Coeff,+N)          CFTG(Coeff,Output-N)');
  For j := 1 to N do
  begin
    s := CmplxToStr0(Cinp[j],13,9)+' |'+CmplxToStr0(Cout[j],13,9)+' |'
        +CmplxToStr0(Cinv[j],13,9);
    Memo1.Lines.Add(s);
  end;

  Memo1.Lines.Add(' ---------------------------------------------------- -----');
  Memo1.Lines.Add('   Interpolation                  Input');
  t := 0.0;
  for m := 1 to 2*N+1 do
  begin
    z := InterpolDFT(t, rN, Cout);
    s := CmplxToStr0(z,13,9);
    j := (m+1) div 2;
    i := (m+1) mod 2;
    if (i=0) and (j<=N) then s := s + ' <-' + CmplxToStr0(Cinp[j],13,9);
    Memo1.Lines.Add(s);
    t := t + 0.5*rN;
  end;
end;

procedure TForm1.ButtonFFTGClick(Sender: TObject);
var
  j, i, N, j1, j2, j3: TInt;
  rN, a , f, ff: TFloat;
  s: string;
  Cinp, Cout, CScr, CInv: ICArr1D;
begin
  Memo1.Clear;
  N := StrToInt(EditN.Text);
  if N < 2 then N := 2;
  rN := 1.0/N;

  Cinp := TCArr1D.Create(N);
  Cout := TCArr1D.Create(N);
  CScr := TCArr1D.Create(N);
  CInv := TCArr1D.Create(N);

  i := StrToInt(EditCycle.Text);
  f := i;
  if i = 0 then ff := 0.101010101 else ff := abs(f);
  
  if RadioGroupTest.ItemIndex = 4 then
    for j := 0 to N-1 do
    begin
      a := 2.0*Pi*f*j/N;
      if CheckBoxIm.Checked then
        Cinp[j+1] := cmplx(-sin(a)*ff, cos(a)*ff)
      else
        Cinp[j+1] := cmplx(cos(a)*ff, sin(a)*ff);
    end
  else
    for j := 0 to N-1 do
    begin
      a := 2.0*Pi*f*j*rN;
      if f < 0.0 then
        Cinp[j+1] := cmplx(sin(a)*ff, 0.0)
      else
        Cinp[j+1] := cmplx(cos(a)*ff, 0.0);
    end;

//  FFTG(Cinp,Cout,CScr,ttDirect);
//  FFTG(Cout,CInv,CScr,ttInverse);
  FFTG(Cinp,Cout,Cinp,ttDirect);
  FFTG(Cout,CInv,Cinp,ttInverse);

  Memo1.Lines.Add(Format('N=%d',[N]));
  Memo1.Lines.Add('   Input                         FFTG(Input,Coeff,ttDirect)    FFTG(Coeff,Output,ttInverse)');
  j1 := Cinp.Lo1;
  j2 := Cout.Lo1;
  j3 := Cinv.Lo1;
  for j := 1 to N do
  begin
    s := CmplxToStr0(Cinp[j1],13,9)+' |'+CmplxToStr0(Cout[j2],13,9)+' |'
        +CmplxToStr0(Cinv[j3],13,9);
    Memo1.Lines.Add(s);
    inc(j1);
    inc(j2);
    inc(j3);
  end;
{
  Memo1.Lines.Add(' ---------------------------------------------------- -----');
  Memo1.Lines.Add('   Interpolation                  Input');
  t := 0.0;
  for m := 1 to 2*N+1 do
  begin
    z := InterpolDFT(t, rN, Cout);
    s := CmplxToStr0(z,13,9);
    j := (m+1) div 2;
    i := (m+1) mod 2;
    if (i=0) and (j<=N) then s := s + ' <-' + CmplxToStr0(Cinp[j],13,9);
    Memo1.Lines.Add(s);
    t := t + 0.5*rN;
  end;
}
end;

procedure TForm1.Captions;
var
  n: integer;
begin
  LabelEven.Visible := RadioGroupTest.ItemIndex = 2;
  if LabelEven.Visible then
  begin
    n := StrToInt(EditN.Text);
    n := (n div 2)*2;
    EditN.Text := IntToStr(n);
  end;

  n := StrToInt(EditCycle.Text);
  
  case RadioGroupTest.ItemIndex of
  0: if n < 0 then
       LabelCyc.Caption := 'Signal: Sin('+IntToStr(abs(n))+'*x)'
     else
       LabelCyc.Caption := 'Signal: Cos('+IntToStr(n)+'*x)';
  1,2,3,4:
  begin
    LabelCyc.Caption := 'Signal: Exp(i*'+IntToStr(n)+'*x)';
    CheckBoxIm.Visible := true;
  end;
  5: if n < 0 then
       LabelCyc.Caption := 'Signal: Sin('+IntToStr(abs(n))+'*x)'
     else
       LabelCyc.Caption := 'Signal: Cos('+IntToStr(n)+'*x)';
  end;
end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  Captions;
end;

procedure TForm1.RadioGroupTestClick(Sender: TObject);
begin
  Captions;
end;

procedure TForm1.EditCycleExit(Sender: TObject);
begin
  Captions;
end;

procedure TForm1.ButtonTestClick(Sender: TObject);
begin
  case RadioGroupTest.ItemIndex of
  0: ButtonFourierR.Click;
  1: ButtonFourier.Click;
  2: ButtonFourierSym.Click;
  3: ButtonCFTG.Click;
  4,5: ButtonFFTG.Click;
  end;

end;

end.
