{@abstract(Test/Demo for uGraph2D, fPlot2D)
@author(Nikolai Shokhirev <nikolai@shokhirev.com> <nikolai@u.arizona.edu>)
@created(June 06, 2002)
@lastmod(August 08, 2003)
Nikolai V. Shokhirev, 2002-2003  }
unit fTestGraph2D;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, uMatTypes, uGraph2D, fPlot2D;

type
  
  TForm1 = class(TForm)
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    EditXmin: TEdit;
    EditXmax: TEdit;
    EditYmin: TEdit;
    ButtonPlot: TButton;
    EditYmax: TEdit;
    CheckBoxX: TCheckBox;
    CheckBoxY: TCheckBox;
    Label5: TLabel;
    EditRatio: TEdit;
    PanelBox: TPanel;
    Button1: TButton;
    procedure ButtonPlotClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    PlotBox2D: TPlotBox2D;
    procedure Plotting;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  math, uDisplay;

{$R *.DFM}

procedure TForm1.Plotting;
var
  Ymax, Ymin, Xmax, Xmin, y : TFloat;
  XAxis, YAxis: boolean;
  NXTicks, NYTicks, i: TInt;
begin
  Xmax := StrToFloat(EditXmax.Text);
  Xmin := StrToFloat(EditXmin.Text);
  NXTicks := 4;

  Ymax := StrToFloat(EditYmax.Text);
  Ymin := StrToFloat(EditYmin.Text);
  NYTicks := 5;

  XAxis := CheckBoxX.Checked;
  YAxis := CheckBoxY.Checked;
  PlotBox2D.SetLimits(Xmin, Xmax, Ymin, Ymax);
  PlotBox2D.PlotFrame;
  PlotBox2D.PenColor := clBlue;
  for i := 1 to 5 do
  begin
    y := Ymin+(i-1)*(Ymax-Ymin)/4;
    PlotBox2D.MoveToF(Xmin,y);
    PlotBox2D.LineToF(Xmin+(Xmax-Xmin)*0.45,y);
    PlotBox2D.MoveToF(Xmax-(Xmax-Xmin)*0.45,y);
    PlotBox2D.LineToF(Xmax, y);
  end;
end;

procedure TForm1.ButtonPlotClick(Sender: TObject);
begin
  PlotBox2D.XCaption := CheckBoxX.Checked;
  PlotBox2D.YCaption := CheckBoxY.Checked;
  Plotting;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  PlotBox2D := TPlotBox2D.Create(self, PanelBox);
  PlotBox2D.OnPaint := ButtonPlotClick;
end;

function f0(const x: TFloat): TFloat;
begin
  if x = 0.0 then
    result := 2.0
  else
    result := 0.25*Sin(8.0*x)/x
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  FormPlot: TFormPlot;
begin
  try
    FormPlot := TFormPlot.Create(nil);
    FormPlot.Xmin := -2.1;
    FormPlot.Xmax :=  2.1;
    FormPlot.Ymin := -2.1;
    FormPlot.Ymax :=  2.1;
    FormPlot.EditIntervals.Text := '64';
    FormPlot.XTitle := 'X-Axis';
    FormPlot.YTitle := 'Y-Axis';
    FormPlot.ReFunc := f0;
    FormPlot.Init;
    FormPlot.Caption := 'Test function';
    FormPlot.ShowModal;
  finally
    FormPlot.Release;
  end;
end;

end.
