unit fTestGrid2D;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  uGrid2D, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    PanelGrid: TPanel;
    ColorDialog1: TColorDialog;
    Panel1: TPanel;
    ButtonRGB: TButton;
    ButtonColor: TButton;
    ButtonGray: TButton;
    ButtonChoose: TButton;
    ButtonClear: TButton;
    Splitter1: TSplitter;
    procedure FormCreate(Sender: TObject);
    procedure ButtonRGBClick(Sender: TObject);
    procedure ButtonClearClick(Sender: TObject);
    procedure ButtonChooseClick(Sender: TObject);
    procedure ButtonGrayClick(Sender: TObject);
    procedure ButtonColorClick(Sender: TObject);
  private
    { Private declarations }
    Grid2D: TGrid2D;
    color: TColor;
    procedure Grid2DPaint(Sender: TObject);
    procedure Grid2DMouseDown(Sender: TObject; Button: TMouseButton;
                                             Shift: TShiftState; X, Y: Integer);
    public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Grid2D := TGrid2D.Create(self,PanelGrid);
  Grid2D.SetRanges(1,9,1,10);
  Grid2D.OnPaint := Grid2DPaint;
  Grid2D.ClearGrid;
  Grid2D.OnMouseDown := Grid2DMouseDown;
  color := clYellow;
  Randomize;
end;

procedure TForm1.Grid2DPaint(Sender: TObject);
begin
  Grid2D.PaintGrid;
end;

procedure TForm1.ButtonRGBClick(Sender: TObject);
begin
  Grid2D[2,3] := clRed;
  Grid2D[3,4] := clGreen;
  Grid2D[4,5] := clBlue;
  Grid2D.PaintGrid;
end;

procedure TForm1.Grid2DMouseDown(Sender: TObject; Button: TMouseButton;
                                            Shift: TShiftState; X, Y: Integer);
var
  i1, i2: integer;
begin
  Grid2D.ScreenToCell(X, Y, i2, i1);
  Grid2D[i1,i2] := color;
  Grid2D.PaintGrid;
end;

procedure TForm1.ButtonClearClick(Sender: TObject);
begin
  Grid2D.ClearGrid;
end;

procedure TForm1.ButtonChooseClick(Sender: TObject);
begin
  if ColorDialog1.Execute then
    color := ColorDialog1.Color;
end;

procedure TForm1.ButtonGrayClick(Sender: TObject);
var
  i1, i2: integer;
begin
  for i1 := Grid2D.Lo1 to Grid2D.Hi1 do
    for i2 := Grid2D.Lo2 to Grid2D.Hi2 do
      Grid2D[i1,i2] := TColor(random(256)*(1 + 256 + 65536));
//    c := i + j*256 + k*65536;
    Grid2D.PaintGrid;
end;

procedure TForm1.ButtonColorClick(Sender: TObject);
var
  i1, i2, i, j, k: integer;
begin
  for i1 := Grid2D.Lo1 to Grid2D.Hi1 do
    for i2 := Grid2D.Lo2 to Grid2D.Hi2 do
    begin
      i := random(256);
      j := random(256);
      k := random(256);
      Grid2D[i1,i2] := TColor(i + j*256 + k*65536);
    end;
  Grid2D.PaintGrid;
end;

end.
