unit fTestGrid2DM;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, uMatTypes, uDynArrays, uGrid2D;

type
  TForm1 = class(TForm)
    PanelGrid: TPanel;
    Panel1: TPanel;
    ButtonCreate: TButton;
    ButtonSum: TButton;
    ButtonGray: TButton;
    ButtonProd: TButton;
    ButtonRand: TButton;
    Splitter1: TSplitter;
    ColorDialog1: TColorDialog;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    ButtonGauss: TButton;
    Button1: TButton;
    Button2: TButton;
    ButtonSin: TButton;
    ButtonSin2: TButton;
    GroupBox1: TGroupBox;
    CheckBoxR: TCheckBox;
    CheckBoxG: TCheckBox;
    CheckBoxB: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure ButtonGrayClick(Sender: TObject);
    procedure ButtonRandClick(Sender: TObject);
    procedure ButtonSumClick(Sender: TObject);
    procedure ButtonProdClick(Sender: TObject);
    procedure ButtonCreateClick(Sender: TObject);
    procedure ButtonGaussClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ButtonSinClick(Sender: TObject);
    procedure ButtonSin2Click(Sender: TObject);
    procedure CheckBoxRClick(Sender: TObject);
    procedure CheckBoxGClick(Sender: TObject);
    procedure CheckBoxBClick(Sender: TObject);
  private
    { Private declarations }
    M: IFArr2D;
    Grid2D: TGrid2DM;
    procedure Grid2DPaint(Sender: TObject);
    procedure Grid2DMouseDown(Sender: TObject; Button: TMouseButton;
                                             Shift: TShiftState; X, Y: Integer);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  uDynArrUtils, uColorMap;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;
  Grid2D := TGrid2DM.Create(self,PanelGrid);
  ButtonCreate.Click;
  Grid2D.OnPaint := Grid2DPaint;
  Grid2D.OnMouseDown := Grid2DMouseDown;
end;

procedure TForm1.ButtonCreateClick(Sender: TObject);
var
  i1, i2: integer;
begin
  i1 := StrToInt(Edit1.Text);
  i2 := StrToInt(Edit2.Text);
  M := TFArr2D.Create(i1,i2);
  RandMt(0.0,1.0,M,0);
  Grid2D.Matrix := M;
  Grid2D.MatrixToColors;
end;

procedure TForm1.Grid2DPaint(Sender: TObject);
begin
  Grid2D.PaintGrid;
end;

procedure TForm1.Grid2DMouseDown(Sender: TObject; Button: TMouseButton;
                                            Shift: TShiftState; X, Y: Integer);
var
  i1, i2: integer;
begin
  Grid2D.ScreenToCell(X, Y, i2, i1);
  ShowMessage(FloatToStr(Grid2D.Values[i1,i2]));
end;

procedure TForm1.ButtonGrayClick(Sender: TObject);
var
  i1, i2: integer;
begin
  for i1 := M.Lo1 to M.Hi1 do
    for i2 := M.Lo2 to M.Hi2 do
      M[i1,i2] := random(256)*(1 + 256 + 65536);
  i1 := RndNum(M.Lo1,M.Hi1);
  i2 := RndNum(M.Lo2,M.Hi2);
  M[i1,i2]:= 16777215;
  i1 := RndNum(M.Lo1,M.Hi1);
  i2 := RndNum(M.Lo2,M.Hi2);
  M[i1,i2]:= 0;
  Grid2D.MatrixToColors;
  Grid2D.PaintGrid;
end;

procedure TForm1.ButtonRandClick(Sender: TObject);
begin
  RandMt(0.0,1.0,M,0);
  Grid2D.MatrixToColors;
  Grid2D.PaintGrid;
end;

procedure TForm1.ButtonSumClick(Sender: TObject);
var
  i1, i2: integer;
begin
  for i1 := M.Lo1 to M.Hi1 do
    for i2 := M.Lo2 to M.Hi2 do
      M[i1,i2] := (i1+i2);
  Grid2D.MatrixToColors;
  Grid2D.PaintGrid;
end;

procedure TForm1.ButtonProdClick(Sender: TObject);
var
  i1, i2: integer;
begin
  for i1 := M.Lo1 to M.Hi1 do
    for i2 := M.Lo2 to M.Hi2 do
      M[i1,i2] := i1*i2;
  Grid2D.MatrixToColors;
  Grid2D.PaintGrid;
end;

procedure TForm1.ButtonGaussClick(Sender: TObject);
var
  i1, i2, i10, i20: TInt;
  d: TFloat;
begin
  i10 := (M.Dim1+1) div 2;
  i20 := (M.Dim2+1) div 2;
  d := M.Dim2*M.Dim1;
  for i1 := M.Lo1 to M.Hi1 do
    for i2 := M.Lo2 to M.Hi2 do
      M[i1,i2] := exp(-6.0*(sqr(i1-i10)+sqr(i2-i20))/d);
  Grid2D.MatrixToColors;
  Grid2D.PaintGrid;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i1, i2, i10, i20: TInt;
begin
  i10 := (M.Dim1+1) div 2;
  i20 := (M.Dim2+1) div 2;
  for i1 := M.Lo1 to M.Hi1 do
    for i2 := M.Lo2 to M.Hi2 do
      M[i1,i2] := (i1-i10)*(i2-i20);
  Grid2D.MatrixToColors;
  Grid2D.PaintGrid;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  i1, i2, i10, i20: TInt;
begin
  i10 := (M.Dim1+1) div 2;
  i20 := (M.Dim2+1) div 2;
  for i1 := M.Lo1 to M.Hi1 do
    for i2 := M.Lo2 to M.Hi2 do
      M[i1,i2] := sqr((i1-i10)*(i2-i20));
  Grid2D.MatrixToColors;
  Grid2D.PaintGrid;
end;

procedure TForm1.ButtonSinClick(Sender: TObject);
var
  i1, i2, i10, i20: TInt;
begin
  i10 := (M.Dim1-1);
  i20 := (M.Dim2-1);
  for i1 := M.Lo1 to M.Hi1 do
    for i2 := M.Lo2 to M.Hi2 do
      M[i1,i2] := Sin(Pi*(i1-1)/i10)*Sin(Pi*(i2-1)/i20);
  Grid2D.MatrixToColors;
  Grid2D.PaintGrid;
end;

procedure TForm1.ButtonSin2Click(Sender: TObject);
var
  i1, i2, i10, i20: TInt;
begin
  i10 := (M.Dim1-1);
  i20 := (M.Dim2-1);
  for i1 := M.Lo1 to M.Hi1 do
    for i2 := M.Lo2 to M.Hi2 do
      M[i1,i2] := Abs(Sin(2.0*Pi*(i1-1)/i10)*Sin(2.0*Pi*(i2-1)/i20));
  Grid2D.MatrixToColors;
  Grid2D.PaintGrid;
end;

procedure TForm1.CheckBoxRClick(Sender: TObject);
begin
  if CheckBoxR.Checked then
    Grid2D.RGBSet := Grid2D.RGBSet + [cR]
  else
    Grid2D.RGBSet := Grid2D.RGBSet - [cR];
  Grid2D.MatrixToColors;
  Grid2D.PaintGrid;
end;

procedure TForm1.CheckBoxGClick(Sender: TObject);
begin
  if CheckBoxG.Checked then
    Grid2D.RGBSet := Grid2D.RGBSet + [cG]
  else
    Grid2D.RGBSet := Grid2D.RGBSet - [cG];
  Grid2D.MatrixToColors;
  Grid2D.PaintGrid;
end;

procedure TForm1.CheckBoxBClick(Sender: TObject);
begin
  if CheckBoxB.Checked then
    Grid2D.RGBSet := Grid2D.RGBSet + [cB]
  else
    Grid2D.RGBSet := Grid2D.RGBSet - [cB];
  Grid2D.MatrixToColors;
  Grid2D.PaintGrid;
end;

end.
