{@abstract(Surface Test)
@author(Nikolai Shokhirev <nikolai@shokhirev.com> <nikolai@u.arizona.edu>)
@created(January 01, 2001)
@lastmod(may 05, 2003)
Nikolai V. Shokhirev, 2001-2003        }
unit fSurfaceTest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, uMatTypes, uSurface, StdCtrls, fSurface;

type
  TForm1 = class(TForm)
    RadioGroup1: TRadioGroup;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function f0(const x, y: TFloat): TFloat;
begin
  result := 8.0-x*x-y*y;
end;

function f1(const x, y: TFloat): TFloat;
begin
  result := x*x+y*y;
end;

function f2(const x, y: TFloat): TFloat;
var
    rr: TFloat;
begin
  rr := x*x+y*y;
  if rr <> 0.0 then rr := Sin(rr*4.0)/rr else rr := 4.0;
  result := rr+2.0;
end;

function f3(const x, y: TFloat): TFloat;
var
    rr: TFloat;
begin
  result := x*y+4.0;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  FormSurface: TFormSurface;
begin
  try
    FormSurface := TFormSurface.Create(nil);
    FormSurface.Xmin := -2.0;
    FormSurface.Xmax :=  2.0;
    FormSurface.Ymin := -2.0;
    FormSurface.Ymax :=  2.0;
    FormSurface.Zmin :=  0.0;
    FormSurface.Zmax :=  8.0;
    FormSurface.Margin := 10;
    FormSurface.SurfaceColor := clRed;
    FormSurface.NInterval := 16;
    case RadioGroup1.ItemIndex of
      0:FormSurface.ZFunc := f0;
      1:FormSurface.ZFunc := f1;
      2:begin
          FormSurface.ZFunc := f2;
          FormSurface.NInterval := 24;
        end;
      3:FormSurface.ZFunc := f3;
    end;
    FormSurface.Init;
    FormSurface.Caption := 'Test function';
    FormSurface.ShowModal;
  finally
    FormSurface.Release;
  end;
end;

end.
