{@abstract(uFunStr unit tests)
@author(Nikolai Shokhirev <nikolai@shokhirev.com> <nikolai@u.arizona.edu>)
@created(2004.01.04)
@lastmod(2004.01.04)
Nikolai V. Shokhirev, 2005-2005 }
unit Test_uFunStr;

interface

uses
  TestFramework,
  uMatTypes,
  SysUtils;

type

Check_FunStr = class(TTestCase)
private
//  x1, x2: TFloat;
//  ErrCode: TInt;
public
   procedure setUp;  override;
   procedure tearDown; override;
published
   procedure VerifyHexB;
   procedure VerifyHexStr2Byte;
end;


function Suite : ITestSuite;

implementation

uses
  uFunStr;
const
  Digits : array[0..$F] of Char = '0123456789ABCDEF';

function Suite : ITestSuite;
begin
  result := TTestSuite.Create('uFunStr Tests');

  result.addTest(Check_FunStr.Suite);
//  result.addTest(Check_Bracketing0.Suite);
//  result.addTest(Check_TOptim1D.Suite);
//  result.addTest(Check_TOptimND.Suite);
end;

{ Check_FunStr }

procedure Check_FunStr.setUp;
begin
  inherited;

end;

procedure Check_FunStr.tearDown;
begin
  inherited;

end;

procedure Check_FunStr.VerifyHexB;
var
  i, j, k : byte;
  s, ss: string;
begin
  k := 0;
  for j := 0 to 15 do
    for i := 0 to 15 do
    begin
      s := (Digits[j]+Digits[i]);
      ss := HexB(k);
      Check(ss=s,'Fail: VerifyHexB k = '+IntToStr(k));
      if k < 255 then inc(k);
    end;
end;

procedure Check_FunStr.VerifyHexStr2Byte;
var
  i, j, k : byte;
  s: string;
begin
  k := 0;
  for j := 0 to 15 do
    for i := 0 to 15 do
    begin
      s := (Digits[j]+Digits[i]);
      Check(k=HexStr2Byte(s),'Fail: VerifyHexStr2Byte s = '+s);
      if k < 255 then inc(k);
    end;
    
  k := 0;
  for j := 0 to 15 do
    for i := 0 to 15 do
    begin
      s := '$'+(Digits[j]+Digits[i]);
      Check(k=HexStr2Byte(s),'Fail: VerifyHexStr2Byte s = '+s);
      if k < 255 then inc(k);
    end;
end;

initialization

  RegisterTest('uFunStr Tests',Suite);

end.
