unit uSys;

interface

procedure SetRunOnStart(CmdLine, ProgTitle: string; RunOnStart: boolean);

implementation

uses
  Classes, SysUtils, Windows, Registry;

//  CmdLine := Application.ExeName;
//  ProgTitle := 'NVS_Reminder';
//  RunOnStart := CheckBoxStart.Checked
procedure SetRunOnStart(CmdLine, ProgTitle: string; RunOnStart: boolean);
var
  SL: TStringList;
  reg: TRegIniFile;
  Section, sOld: string;
  idx: integer;
  SectionExists: boolean;
begin
  idx := -1;
  SL := TStringList.Create;
  SL := TStringList.Create;
  reg := TRegIniFile.Create( '' );
  try
    reg.RootKey := HKEY_LOCAL_MACHINE;
    Section := 'Software\Microsoft\Windows\CurrentVersion\Run\';
    SectionExists := reg.KeyExists(Section);
    if SectionExists then
    begin
      reg.ReadSectionValues(Section,SL);
      idx := SL.IndexOfName(ProgTitle);
      if idx > -1 then
      begin
        sOld := SL.Values[ProgTitle];
        if not SameText(sOld, CmdLine) then
        begin
          reg.DeleteKey(Section, ProgTitle);
          idx := -1;
        end;
      end;
    end;

    if RunOnStart then
    begin
      if not SectionExists or (idx = -1) then
        reg.WriteString('Software\Microsoft\Windows\CurrentVersion\Run' + #0,
                         ProgTitle, CmdLine );
    end else
    begin
      if SectionExists and (idx > -1) then
        reg.DeleteKey(Section, ProgTitle);
    end;
  finally
    reg.Free;
    SL.Free;
  end;
end;

end.
 